import os
import h5py
import pandas as pd
from allensdk.brain_observatory.behavior.swdb import behavior_project_cache as bpc
from allensdk.brain_observatory.behavior.swdb import utilities as ut


cache_json = {'manifest_path': '/allen/programs/braintv/workgroups/nc-ophys/visual_behavior/SWDB_2019/visual_behavior_data_manifest.csv',
              'nwb_base_dir': '/allen/programs/braintv/workgroups/nc-ophys/visual_behavior/SWDB_2019/nwb_files',
              'analysis_files_base_dir': '/allen/programs/braintv/workgroups/nc-ophys/visual_behavior/SWDB_2019/analysis_files',
              'analysis_files_metadata_path': '/allen/programs/braintv/workgroups/nc-ophys/visual_behavior/SWDB_2019/analysis_files_metadata.json',
              }

cache = bpc.BehaviorProjectCache(cache_json)
manifest = cache.manifest
experiment_ids = manifest.ophys_experiment_id.unique()

print('generating mega_trial_mdf')
mega_trial_mdf = ut.create_multi_session_mean_df(cache, experiment_ids,  conditions=['cell_specimen_id','change_image_name'])
save_dir = r'/allen/programs/braintv/workgroups/nc-ophys/visual_behavior/SWDB_2019'
mega_trial_mdf.to_hdf(os.path.join(save_dir, 'multi_session_mean_trials_df.h5'), key='df')
print('done with trials, creating mega_flash_mdf')
mega_flash_mdf = ut.create_multi_session_mean_df(cache, experiment_ids, flashes=True, conditions=['cell_specimen_id','image_name'])
save_dir = r'/allen/programs/braintv/workgroups/nc-ophys/visual_behavior/SWDB_2019'
mega_flash_mdf.to_hdf(os.path.join(save_dir, 'multi_session_mean_flashes_df.h5'), key='df')
print('done with flash df')