from argschema import ArgSchema, ArgSchemaParser
from argschema.schemas import DefaultSchema
from argschema.fields import LogLevel, String, Int, DateTime, Nested, Boolean, Float, List, Dict
from marshmallow import RAISE, ValidationError

from allensdk.brain_observatory.argschema_utilities import check_read_access, check_write_access_overwrite, RaisingSchema

class InputSchema(ArgSchema):
    class Meta:
        unknown = RAISE
    log_level = LogLevel(default='INFO', description='set the logging level of the module')
    rule = String(default='run', required=False)
    dockerfile = String(required=True, validate=check_read_access, description='Dockerfile for image')
    modelfile = String(required=True, validate=check_read_access, description='Zip file for model')
    video_input_file = String(required=True, validate=check_read_access, description='Eye tracking movie')
    ellipse_output_data_file = String(required=True, validate=check_write_access_overwrite, description='write outputs to here')
    ellipse_output_video_file = String(required=False, validate=check_write_access_overwrite, description='write outputs to here')
    points_output_video_file = String(required=False, validate=check_write_access_overwrite, description='write outputs to here')

class OutputSchema(RaisingSchema):
    output_path = String(required=True, description='write outputs to here')