import sys
try:
    # for Python 3.8 and greater
    from typing import Protocol
except ImportError:
    # for Python 3.7 and before
    from typing import _Protocol as Protocol
    
from abc import abstractmethod


class SupportsStr(Protocol):
    """Classes that support the __str__ method"""
    @abstractmethod
    def __str__(self) -> str:
        pass
